-- NumWord.ex: A number to words -  Vs 1.0  17.02.1999
-- Input     : A integer number or zero.
-- Output    : A number in words.
-- Range     : From 0 to 999999999
-- Use in    : Cheques, reports, etc.
-- Comments  : English version. This is a traslation to Euphoria
--             of old routine from my collecction.
--
-- Author    : Guillermo Friant  - Santiago, Chile
-- E-mail    : friguz@cmet.net


sequence nump

constant casos = {"one","two","three","four","five","six","seven","eight",
		"nine","ten","eleven","twelve","thirteen","fourteen",
		"fifteen","sixteen","seventeen","eighteen","nineteen",
		"twenty-","thirty","fourty","fifty","sixty",
		"seventy","eighty","ninety"},
	 -- specials
	 zero   = "zero",
	 twenty = "twenty"

procedure num_pal(integer number)
  integer digito,decena,centena,nc
  -- validate range
  if number<0 or number >999 then
     puts(1,"Number not valid!")
     abort(1)
  end if

  if number=20 then
     nump=nump & twenty
  end if
  if number <20 then
     nump=nump & casos[number]
  else
     centena=floor(number/100)
     nc=remainder(number,100)
     decena=floor(nc/10)
     digito=remainder(nc,10)
     if centena > 0 then
        nump=nump & casos[centena] & " hundred "
     end if
     if digito > 0  and decena>2 then
        nump=nump & casos[decena+18] & " " & casos[digito]
     end if
     if digito >0 and decena=2 then
        nump=nump & casos[decena+18] & casos[digito]
     end if
     if digito =0 and decena=2 then
        nump=nump & twenty
     end if
     if digito >0 and decena=1 then
        nump=nump & casos[decena*10+digito]
     end if
     if digito = 0  and decena > 2 then
        nump=nump & casos[decena+18]
     end if
     if digito >0 and decena = 0 then
        nump=nump & casos[digito]
     end if
  end if
end procedure


global function words(integer number)

integer n1,n2,n3,n

nump = {}  -- to save number in words


--discompose in three hundreds (0 to 999)
n1=floor(number/1000000)
n=remainder(number,1000000)
n2=floor(n/1000)
n3=remainder(n,1000)

--zero is special
if n1=0 and n2=0 and n3=0  then nump=zero
end if

--others
if n1 > 0 then
   num_pal(n1)
   --if n1=1 then
      nump=nump & " million "
   --else
     --nump=nump & " millones "
   --end if
end if
if n2 > 0 then
   num_pal(n2)
   nump=nump & " thousand "
end if
if n3 > 0  then
   num_pal(n3)
end if

return nump

end function


