-- num_pal.ex: Vs.1.0 Inicio 15.02.1999
-- Objetivo  : Entregar en palabras un numero entero positivo o igual a cero
-- Entrada   : Un numero entero positivo o igual a cero
-- Salida    : El numero en palabras.
-- Rango     : maneja numeros de 0 a 999999999
-- Uso       : llenar facturas, cheques o cualquier documento
--             que requiera especificar un numero en palabras
--
-- Nota      : Adaptacion a Euphoria de una util rutina de mi
--             coleccion particular de rutinas.
--
-- Autor     : Guillermo Friant -- Santiago, Chile
-- E-mail    : friguz@cmet.net
--

sequence nump

constant casos = {"un","dos","tres","cuatro","cinco","seis","siete",
		"ocho","nueve","diez","once","doce","trece","catorce",
		"quince","dieciseis","diecisiete","dieciocho","diecinueve",
		"veinti","treinta","cuarenta","cincuenta","sesenta",
		"setenta","ochenta","noventa","quinientos","seiscientos",
		"setecientos","ochocientos","novecientos"},
	 -- especiales
	 cero   = "cero ",
	 veinte = "veinte ",
	 cien   = "cien " ,
	 ciento = "ciento ",
	 cientos= "cientos "


procedure num_pal(integer numero)
  integer digito,decena,centena,nc
  -- valida rango
  if numero<0 or numero >999 then
     puts(1,"No es numero vlido!")
     abort(1)
  end if

  if numero=20 then
     nump=nump & veinte
  end if

  if numero <20 then
     nump=nump & casos[numero]
  else
     centena=floor(numero/100)
     nc=remainder(numero,100)
     decena=floor(nc/10)
     digito=remainder(nc,10)
     if centena > 0 then
        if centena = 1  then
	   if decena=0 and digito=0 then
	      nump=nump & cien
	   else
	      nump=nump & ciento
	   end if
        else
	   if centena > 4 then
	      nump=nump & casos[centena+23] & " "
	   else
	      nump=nump & casos[centena] & cientos
	   end if
        end if
     end if
     if digito > 0  and decena>2 then
        nump=nump & casos[decena+18] & " y " & casos[digito]
     end if
     if digito >0 and decena=2 then
        nump=nump & casos[decena+18] & casos[digito]
     end if
     if digito =0 and decena=2 then
        nump=nump & veinte
     end if
     if digito >0 and decena=1 then
        nump=nump & casos[decena*10+digito]
     end if
     if digito = 0  and decena > 2 then
        nump=nump & casos[decena+18]
     end if
     if digito >0 and decena = 0 then
        nump=nump & casos[digito]
     end if
  end if
end procedure



global function palabras(integer numero)

  integer n1,n2,n3,n

  nump={}

  --descompone el numero en tres centenas
  n1=floor(numero/1000000)
  n=remainder(numero,1000000)
  n2=floor(n/1000)
  n3=remainder(n,1000)

  --maneja caso especial
  if n1=0 and n2=0 and n3=0  then nump=cero
  end if

  --maneja casos generales
  if n1 > 0 then
     num_pal(n1)
    if n1=1 then
        nump=nump & " millon "
    else
       nump=nump & " millones "
    end if
  end if
  if n2 > 0 then
     num_pal(n2)
     nump=nump & " mil "
  end if
  if n3 > 0  then
     num_pal(n3)
  end if

return nump -- el numero en palabras

end function


